﻿/*jslint maxlen: 80, maxerr: 999, white: true, browser: true, sloppy: true*/
/*global $0, jQuery, chrome*/
// The function below is executed in the context of the inspected page.
var getProperties =
     function ()
     {
      var data = window.jQuery && $0 ? (jQuery._data($0, "events") || {}) : {},
          i, j, props, copy;
  
      // // Make a shallow copy with a null prototype, so that sidebar does not
      // // expose prototype.
      // function createFunctionLines(str)
      // {
      //  var lines = str.split(/\r\n|\n/g), literalLines = {}, i = 0;
      //  while (lines.length)
      //  {
      //   literalLines["l" + i] = lines.shift();
      //   i++;
      //  }
       return literalLines;
      }
      props = Object.getOwnPropertyNames(data);
      copy = {__proto__: null};
      for (i = 0; i < props.length; ++i)
      {
       copy[props[i]] = [];
       for (j = 0; j < data[props[i]].length; ++j)
       {
        copy[props[i]].push(data[props[i]][j].handler);
         //createFunctionLines(data[props[i]][j].handler.toString());
       }
      }
      return copy;
     };

chrome.devtools.panels.elements.createSidebarPane(
 "jQuery Events",
 function (sidebar)
 {
  function updateElementProperties()
  {
   sidebar.setExpression("(" + getProperties.toString() + ")()");
  }
  updateElementProperties();
  chrome.devtools.panels.elements.onSelectionChanged.addListener(
   updateElementProperties);
 });